#pip install numpy, matplotlib, PIL
#
#Le rouge est code (255,0,0), le vert (0,255,0), le bleu (0,0,255),
#le blanc (255,255,255) et le noir (0,0,0)
#img[i,j]=(c[0]+m,c[1]-m,c[2])   #r,v,b
#from more_itertools import flatten
import math
import cmath
import matplotlib.image as mpimg
import matplotlib.pyplot as plt
import numpy as np
import datetime


pixels_ori = 1000   #cela peut prendre du temps, reduire eventuellement la taille
xmin_ori = -4
xmax_ori = 2
ymin_ori = -3
ymax_ori = 3
bouclesmax = 100
z_ori = 1
quitch = ""

while quitch == "":

    pixelsch = input("pixels (1000): ")
    x0ch = input("x0 (0): ")
    y0ch = input("y0 (0): ")
    nch = input("puissance (2): ")
    zch = input("zoom (1): ")   # a verifier
    N1ch = input("seuil 1 (20): ")
    N2ch = input("seuil 2 (200): ")
    N3ch = input("seuil 3 (2000): ")

    if pixelsch == "":
        pixels = pixels_ori
    else :
        pixels = int(pixelsch)


    if x0ch == "":
        x0=0
    else :
        x0=(float(x0ch)-(pixels_ori/2))/pixels*(xmax_ori-xmin_ori)

    if y0ch == "":
        y0=0
    else :
        y0=((pixels_ori/2)-float(y0ch))/pixels*(ymax_ori-ymin_ori)

    if zch == "":
        z=z_ori
    else :
        z=int(zch)


    if N1ch == "":
       N1 = 20
    else :
        N1 = int(N1ch)

    if N2ch == "":
       N2 = 200
    else :
        N2 = int(N2ch)

    if N3ch == "":
       N3 = 2000
    else :
        N3 = int(N3ch)

    if nch == "":
        n=2
    else :
        n=float(nch)

    xmin = x0 + xmin_ori/z
    ymin = y0 + ymin_ori/z
    xmax = x0 + xmax_ori/z
    ymax = y0 + ymax_ori/z
    Px = pixels/(xmax-xmin)
    Py = pixels/(ymax-ymin)
    N= sorted([N1,N2,N3])
    Psym = int(pixels/2)
    print(x0,y0,xmin,xmax,ymin,ymax,z)

    start_delay = datetime.datetime.now()
    img = np.zeros((pixels,pixels,3),dtype=np.uint8)

    for line in range(Psym+1):
        for col in range(pixels):
            zn=complex(0,0)
            Orbite=[0]
            i = 1
            x = xmin+col*(xmax-xmin)/pixels
            y = ymax-line*(ymax-ymin)/pixels
            c=complex(x,y)

            p = (1-2*(((c.real-0.25)**2) + (c.imag**2))**.5)*(((c.real-0.25)**2) + (c.imag**2))**.5+0.25

            if c.real >p and ((c.real+1)**2) + (c.imag**2) > 0.0625:

                while i<=N[0] and max(abs(c),abs(zn))<=9:
                    zn = zn**n+c
                    Orbite.append(zn)
                    i += 1
                if max(abs(c),abs(zn))>2:
                    for Z in [z0 for z0 in Orbite if z0.real<xmax_ori and z0.real>xmin_ori and z0.imag>ymin_ori and z0.imag<ymax_ori]:
                        img[math.floor((Z.real-xmin)*Px),math.floor((ymax-Z.imag)*Py)] = img[math.floor((Z.real-xmin)*Px),math.floor((ymax-Z.imag)*Py)]+(5,10,15)
                        img[math.floor((Z.real-xmin)*Px),-math.floor((ymax-Z.imag)*Py)] = img[math.floor((Z.real-xmin)*Px),math.floor((ymax-Z.imag)*Py)]
                Orbite=[]
                while i<=N[1] and max(abs(c),abs(zn))<=9:
                    zn = zn**n+c
                    Orbite.append(zn)
                    i += 1
                if max(abs(c),abs(zn))>2:
                    for Z in [z0 for z0 in Orbite if z0.real<xmax_ori and z0.real>xmin_ori and z0.imag>ymin_ori and z0.imag<ymax_ori]:
                        img[math.floor((Z.real-xmin)*Px),math.floor((ymax-Z.imag)*Py)] = img[math.floor((Z.real-xmin)*Px),math.floor((ymax-Z.imag)*Py)]+(5,10,0)
                        img[math.floor((Z.real-xmin)*Px),-math.floor((ymax-Z.imag)*Py)] = img[math.floor((Z.real-xmin)*Px),math.floor((ymax-Z.imag)*Py)]

                Orbite=[]
                while i<=N[2] and max(abs(c),abs(zn))<=9:
                    zn = zn**n+c
                    Orbite.append(zn)
                    i += 1
                if max(abs(c),abs(zn))>2:
                    for Z in [z0 for z0 in Orbite if z0.real<xmax_ori and z0.real>xmin_ori and z0.imag>ymin_ori and z0.imag<ymax_ori]:
                        img[math.floor((Z.real-xmin)*Px),math.floor((ymax-Z.imag)*Py)] = img[math.floor((Z.real-xmin)*Px),math.floor((ymax-Z.imag)*Py)]+(5,0,0)
                        img[math.floor((Z.real-xmin)*Px),-math.floor((ymax-Z.imag)*Py)] = img[math.floor((Z.real-xmin)*Px),math.floor((ymax-Z.imag)*Py)]


    mpimg.imsave("Buddhabrot-"+str(pixels)+"-"+str(N3)+"-"+str(N1)+"-"+str(N2)+"-"+str(z)+"-"+x0ch+"-"+y0ch+"-"+str(n)+".png",img)

    duree = datetime.datetime.now() - start_delay
    print("Duree : "+str(duree.seconds)+" s")
    print("affichage")

    plt.imshow(img)
    plt.title("Buddhabrot-"+pixelsch+"-"+x0ch+"-"+y0ch+"-"+str(z))
    plt.show()


    quitch = input("continue (rc), quit (other): ")