import random
import numpy as np
import matplotlib.image as mpimg

rangemax = 10000000

height = 1000
width = 1000

img = np.full((height,width,3),255,dtype=np.uint8)

xmin = -2.1820
xmax = 2.6558

ymin = 0
ymax = 9.9983

def pixel(x,y):
    return (int((x-xmin)*width/(xmax-xmin)),int(-y*height/(ymax-ymin)))

x = 0
y = 0

img[pixel(0,0)[1],pixel(0,0)[0]] = (0,150,0)

for n in range(rangemax):
    
    r = random.uniform(0, 100)
    
    if r < 1.0:                                                                #tige
        
        Nextx = 0
        Nexty = 0.16*y
        
    elif r < 86.0:                                                             #reduction des branches
        
        Nextx =  0.85*x + 0.04*y
        Nexty = -0.04*x + 0.85*y + 1.6
        
    elif r < 93.0:                                                             #premiere branche gauche
        
        Nextx =  0.20*x - 0.26*y
        Nexty =  0.23*x + 0.22*y + 1.6
        
    else:                                                                      #premiere branche droite
        
        Nextx = -0.15*x + 0.28*y
        Nexty =  0.26*x + 0.24*y + 0.44
        
    x = Nextx
    y = Nexty
    img[pixel(x,y)[1],pixel(x,y)[0]] = (0,150,0)
    
    
mpimg.imsave(r"C:\Users\Moi\Desktop\Barnsley_fern.png",img)

