
import math as math
import cmath as cmath
import matplotlib.image as mpimg
import matplotlib.pyplot as plt
import numpy as np
import datetime

#definit la fenetre:

xmin =-1.5
xmax = 1.5
ymin =-1.5
ymax = 1.5

# entree des parametres

quitch = ""

while quitch == "":

    pixels = input("Taille de l image (400 pixels par defaut) = ")
    a = input("Partie reele de c (-0.123 par defaut): a = ")
    b = input("Partie imaginaire de c (0.745 par defaut): b =")
    nch = input("Iterees niemes (n=14 par defaut): n =")
    z = input("zoom (1 par defaut): z =")
    x0 = input("Centre de la zone de zoom (0 par defaut): x0 =")
    y0 = input("Centre de la zone de zoom (0 par defaut): y0 =")

    if pixels == "":
        pixels = 400
    else :
        pixels = int(pixels)
    if a == "":
        a=-0.123
    else :
        a=float(a)

    if b == "":
        b=0.745
    else :
        b=float(b)

    if nch == "":
       n = 14
    else :
        n = int(nch)

    if x0 == "":
        x0=0
    else :
        x0=(float(x0)-(pixels/2))/(pixels)*(xmax-xmin)

    if y0 == "":
        y0=0
    else :
        y0=((pixels/2)-float(y0))/(pixels)*(ymax-ymin)

    if z == "":
        z=1
    else :
        z=int(z)

    xmin = x0 + xmin/z
    ymin = y0 + ymin/z
    xmax = x0 + xmax/z
    ymax = y0 + ymax/z


    d=2**(n)-1
    c=complex(a,b)

    z2=0.5*(1-(1-4*c)**0.5)  #Premier point fixe
    X=[z2.real]*d
    Y=[z2.imag]*d
    L=[0]*d
    L[0]=z2
    z1=-z2                   #Second point fixe
    X1=[z1.real]*d
    Y1=[z1.imag]*d
    L1=[0]*d
    L1[0]=z2

    for k in range(1,n):
        for i in range(2**k):   # il y a deux fois plus de valeurs à chaque étape, donc 2**k
            if i%2 == 0:        #si i est pair on stocke le premier antecedent
                L[2**(k)-1+i]=(L[int(2**(k)-2**(k-1)+i/2-1)]-c)**0.5
                X[2**(k)-1+i]=L[2**(k)-1+i].real
                Y[2**(k)-1+i]=L[2**(k)-1+i].imag
                L1[2**(k)-1+i]=(L1[int(2**(k)-2**(k-1)+i/2)-1]-c)**0.5
                X1[2**(k)-1+i]=L1[2**(k)-1+i].real
                Y1[2**(k)-1+i]=L1[2**(k)-1+i].imag
            if i%2 == 1:        # si i est impair on stocke l'opposé qui correspond au deuxieme antecedent
                L[2**(k)-1+i]= -(L[int(2**k-2**(k-1)+(i+1)/2-1)]-c)**0.5
                X[2**(k)-1+i]=L[2**(k)-1+i].real
                Y[2**(k)-1+i]=L[2**(k)-1+i].imag
                L1[2**(k)-1+i]= -(L1[int(2**(k)-2**(k-1)+i/2-1)]-c)**0.5
                X1[2**(k)-1+i]=L1[2**(k)-1+i].real
                Y1[2**(k)-1+i]=L1[2**(k)-1+i].imag


    print(pixels,a,b,n,z,x0,y0)

    start_delay = datetime.datetime.now()
    img = np.zeros((pixels,pixels,3),dtype=np.uint8)

    for f in L+L1: #parcourt les deux listes pour associer une coloration au pixel correspondant

        img[math.floor(pixels/2+f.imag*pixels/(ymax-ymin)),math.floor(pixels/2-f.real*pixels/(xmax-xmin))] = (255,0,0)

    infos = str(pixels)+"-"+str(a)+"-"+str(b)+"-"+str(x0)+"-"+str(y0)+"-"+str(n)+"-"+str(z)

    duree = datetime.datetime.now() - start_delay
    print("Duree : "+str(duree.seconds)+" s")
    print("Affichage")

    plt.imshow(img)
    plt.title("Julia-"+infos)
    plt.show()

    mpimg.imsave("JuliaFrontiere-"+infos+".png",img)

    quitch = input("continue (rc), quit (other): ")

